{% load widget_tweaks %}

<form method="post" novalidate>
  {% csrf_token %}

  {% for hidden_field in user_form.hidden_fields %}
    {{ hidden_field }}
  {% endfor %}

  {% if user_form.non_field_errors %}
    <div class="alert alert-danger" role="alert">
      {% for error in user_form.non_field_errors %}
       <p style="color: #2ecc71"> {{ error }}</p>
      {% endfor %}
    </div>
  {% endif %}

  {% for field in user_form.visible_fields %}
    <div class="form-group">
      {{ field.label_tag }}

      {% if user_form.is_bound %}
        {% if field.errors %}
          {% render_field field class="form-control is-invalid" %}
          {% for error in field.errors %}
            <div class="invalid-feedback">
               <p style="color: red"> {{ error }}</p>
            </div>
          {% endfor %}
        {% else %}
          {% render_field field class="form-control is-valid" %}
        {% endif %}
      {% else %}
        {% render_field field class="form-control" %}
      {% endif %}

      {% if field.help_text %}
        <small class="form-text text-muted" >{{ field.help_text }}</small>
      {% endif %}
    </div>
  {% endfor %}

  <button type="submit" class="btn btn-primary">Submit</button>
</form>